Subject: [ppsp] Call for WG consensus on Tracker Protocol encoding

From: Zongning <[email-masked]>
Date: Thu, 13 Nov 2014 02:27:42 +0000

Hi, all,

Firstly, thanks to the co-authors of Base Tracker Protocol for persistently moving the draft forward.

Now the outstanding issue is that as a Standard Track document, we really NEED to agree on a mandatory encoding for the interoperable on-the-wire Tracker Protocol. As discussed in the PPSP session today, we will start WGLC for the draft, provided that we can reach a rough consensus on the encoding option and the co-authors revise the draft accordingly.

Currently we have two options mentioned in the draft - they are text based and binary based. For an exemplary comparison, please see Section 3.1 in the draft. Could folks in the group give their opinions on which encoding option is preferred for Tracker Protocol, and why? People are welcome to give other options beyond text and binary, but please do show us the reason for choosing them.

The during of this call will not last too long, before the co-chairs will make a decision. So, please do contribute your technical expertise in this perspective, to enlight the group.

Thanks.

-Yunfei & Ning

---

From: "Huangyihong (Rachel)" <[email-masked]>
Date: Thu, 13 Nov 2014 08:04:47 +0000

Hi  all,

IMHO, text encoding makes more sense to me. It's prevalently used in application protocols over HTTP (e.g., alto protocol). And maybe we could use standard languages, like JSON or YANG to specify our messages (not just current C language). As for the efficiency issue,  it may be more efficient when parsing the binary encoding than text encoding. But the advantage is very limited from my point of view. And I don't see such  efficient issue raised in current web servers (which accept text encoding).

BR,
Rachel

From: ppsp [mailto:[email-masked]] On Behalf Of Zongning
Sent: Thursday, November 13, 2014 10:28 AM
To: [email-masked]
Subject: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi, all,

Thanks.

-Yunfei & Ning

---

From: João Pedro Taveira <[email-masked]>
Date: Thu, 13 Nov 2014 13:14:03 +0000

Hi to all,

About the specification language to used, I don't prefer this or other
language. Arno already sugested XDR and Rachel sugested JSON or YANG. I
think that base protocol is well defined in high level point of view. The
main issue is on-the-wired encoding.

Personally, I prefer binary encoded protocols. They are compact, and if
well defined, they are simple and very efficient. The problem is that they
are complex to use and/or implement.

The Tracker Protocol should be text encoded (imho, JSON) on-the-wired over
HTTP, for now. This will allow faster testing and adoption. Since messages
are historically defined in a hierarchical way from XML sharing elements,
we will be able to discuss binaries hierarchical structures (e.g. mp4box or
something like icmp) to get a binary encoding that match current abstract
protocol.

For now, I think we should use JSON over HTTP.

Best Regards,
João Pedro Taveira

On Thu Nov 13 2014 at 8:05:21 AM Huangyihong (Rachel) <
[email-masked]> wrote:

>  Hi  all,
>
>
>
> IMHO, text encoding makes more sense to me. It’s prevalently used in
> application protocols over HTTP (e.g., alto protocol). And maybe we could
> use standard languages, like JSON or YANG to specify our messages (not just
> current C language). As for the efficiency issue,  it may be more efficient
> when parsing the binary encoding than text encoding. But the advantage is
> very limited from my point of view. And I don’t see such  efficient issue
> raised in current web servers (which accept text encoding).
>
>
>
> BR,
>
> Rachel
>
>
>
> *From:* ppsp [mailto:[email-masked]] *On Behalf Of *Zongning
> *Sent:* Thursday, November 13, 2014 10:28 AM
> *To:* [email-masked]
> *Subject:* [ppsp] Call for WG consensus on Tracker Protocol encoding
>
>
>
> Hi, all,
>
>
>
> Now the outstanding issue is that as a Standard Track document, we really
> NEED to agree on a mandatory encoding for the interoperable on-the-wire
> Tracker Protocol. As discussed in the PPSP session today, we will start
> WGLC for the draft, provided that we can reach a rough consensus on the
> encoding option and the co-authors revise the draft accordingly.
>
>
>
> Currently we have two options mentioned in the draft – they are text based
> and binary based. For an exemplary comparison, please see Section 3.1 in
> the draft. Could folks in the group give their opinions on which encoding
> option is preferred for Tracker Protocol, and why? People are welcome to
> give other options beyond text and binary, but please do show us the reason
> for choosing them.
>
>
>
> The during of this call will not last too long, before the co-chairs will
> make a decision. So, please do contribute your technical expertise in this
> perspective, to enlight the group.
>
>
>
> Thanks.
>
>
>
> -Yunfei & Ning
>  _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>

---

From: "Prof. Rui Santos Cruz Eng." <[email-masked]>
Date: Thu, 13 Nov 2014 13:49:53 +0000

Hi Folks,

The current version of the Base Tracker Protocol draft had followed all previous recommendations of the WG, and, as you may recall, the initial specifications described a text-based encoding (HTTP/XML) that could even be represented in binary form on the wire.

Later, it was recommended in the WG to "specify the protocol" not using a specific encoding method as it would seem as mandatory, and that was done using a syntax and format for the Protocol messages defined with a C-like syntax, similar to the presentation language used to defined TLS, just to “document” the protocol. Consequently, the encoding “examples" (HTTP/XML) for the protocol were removed from the document, remaining only in part 4 of the draft the mention:

“PPSP-TP is a message-oriented request/response protocol.  The messages can be encoded using binary type or text type, which can be indicated in the Content-Type field in HTTP/1.1 [RFC2616], but that definition is not in the scope of this specification.” 

I personally welcome the chance given by the WG to have a mandatory encoding specification for the protocol, and I am convinced that it would be just a question of getting the consensus on using one of the following:

1. HTTP/XML: just pure text but also directly representable in binary format on the wire (in "real-time") using current well known methods and standards.
2. HTTP/JSON: just pure text but also directly representable in binary format on the wire (in "real-time”) using current well known methods and standards.

None of those require special work from what was described and exemplified in earlier versions of the draft (HTTP/XML), just a simple transcription of previous text to the current document, or a transcription of the previous text but with a conversion of the messages body to JSON (XML to JSON is straightforward).

As other co-authors also mentioned, a pure binary format, although apparently more “efficient” on the wire, would bring unnecessary complexity to the implementation, usage and extensibility.

Thanks. 

Regards,

Dr. Rui Santos Cruz, Ph.D.
[email-masked]

IST/INESC-ID/INOV - Lisbon, Portugal
__________________________________________
ppsp mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/ppsp

> On 13 Nov 2014, at 02:27, Zongning <[email-masked]> wrote:
> 
> Hi, all,
>  
> Currently we have two options mentioned in the draft – they are text based and binary based. For an exemplary comparison, please see Section 3.1 in the draft. Could folks in the group give their opinions on which encoding option is preferred for Tracker Protocol, and why? People are welcome to give other options beyond text and binary, but please do show us the reason for choosing them.
>  
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/ppsp <https://www.ietf.org/mailman/listinfo/ppsp>

---

From: "Mario Nunes" <[email-masked]>
Date: Thu, 13 Nov 2014 13:50:55 -0000

Hi all

I support Joao’s, opinion on text based messages.

In ITU-T there is a long record of binary encoding due to bandwidth constrains but in IETF there is a large support for text based, due to its higher readability and simplicity for debugging.

Concerning the syntax of the messages I see at least three alternatives:

- SDP 

- XML

- JSON

SDP is very successful e.g. for SIP but is not used for new protocols for some time now

Between XML and JSONB I definitely support JSON for a number of reasons,  namely because it is ligher and more readable than XML, and has more support in IETF, as you can read in this article:

 <http://www.internetsociety.org/articles/using-json-ietf-protocols> http://www.internetsociety.org/articles/using-json-ietf-protocols

Best regard

Mário Nunes

From: ppsp [mailto:[email-masked]] On Behalf Of João Pedro Taveira
Sent: 13 de novembro de 2014 13:14
To: Huangyihong (Rachel); Zongning; [email-masked]
Subject: Re: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi to all,

About the specification language to used, I don't prefer this or other language. Arno already sugested XDR and Rachel sugested JSON or YANG. I think that base protocol is well defined in high level point of view. The main issue is on-the-wired encoding. 

Personally, I prefer binary encoded protocols. They are compact, and if well defined, they are simple and very efficient. The problem is that they are complex to use and/or implement.

The Tracker Protocol should be text encoded (imho, JSON) on-the-wired over HTTP, for now. This will allow faster testing and adoption. Since messages are historically defined in a hierarchical way from XML sharing elements, we will be able to discuss binaries hierarchical structures (e.g. mp4box or something like icmp) to get a binary encoding that match current abstract protocol.

Best Regards,

João Pedro Taveira

On Thu Nov 13 2014 at 8:05:21 AM Huangyihong (Rachel) <[email-masked] <mailto:[email-masked]> > wrote:

Hi  all,

IMHO, text encoding makes more sense to me. It’s prevalently used in application protocols over HTTP (e.g., alto protocol). And maybe we could use standard languages, like JSON or YANG to specify our messages (not just current C language). As for the efficiency issue,  it may be more efficient when parsing the binary encoding than text encoding. But the advantage is very limited from my point of view. And I don’t see such  efficient issue raised in current web servers (which accept text encoding). 

BR,

Rachel

From: ppsp [mailto:[email-masked] <mailto:[email-masked]> ] On Behalf Of Zongning
Sent: Thursday, November 13, 2014 10:28 AM
To: [email-masked] <mailto:[email-masked]> 
Subject: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi, all,

Thanks.

-Yunfei & Ning

---

From: Xiajinwei <[email-masked]>
Date: Thu, 13 Nov 2014 19:35:56 +0000

I am personally inclined to the text encoding as it is more legible for readers. Using XML, JSON or YANG is all OK for me.

Jinwei

发件人: ppsp [mailto:[email-masked]] 代表 Mario Nunes
发送时间: 2014年11月13日 21:51
收件人: 'João Pedro Taveira'; Huangyihong (Rachel); Zongning; [email-masked]
主题: Re: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi all

- SDP
- XML
- JSON

http://www.internetsociety.org/articles/using-json-ietf-protocols

Best regard
Mário Nunes

From: ppsp [mailto:[email-masked]] On Behalf Of João Pedro Taveira
Sent: 13 de novembro de 2014 13:14
To: Huangyihong (Rachel); Zongning; [email-masked]<mailto:[email-masked]>
Subject: Re: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi to all,

Best Regards,
João Pedro Taveira

On Thu Nov 13 2014 at 8:05:21 AM Huangyihong (Rachel) <[email-masked]<mailto:[email-masked]>> wrote:
Hi  all,

BR,
Rachel

From: ppsp [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Zongning
Sent: Thursday, November 13, 2014 10:28 AM
To: [email-masked]<mailto:[email-masked]>
Subject: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi, all,

Thanks.

-Yunfei & Ning
_______________________________________________
ppsp mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/ppsp

---

From: 邓灵莉/Lingli Deng <[email-masked]>
Date: Fri, 14 Nov 2014 03:42:43 +0800

I prefer text encoding too, and JSON would be the one for me.

Lingli

From: ppsp [mailto:[email-masked]] On Behalf Of Xiajinwei
Sent: Friday, November 14, 2014 3:36 AM
To: [email-masked]; 'João Pedro Taveira'; Huangyihong (Rachel); Zongning; [email-masked]
Subject: [ppsp] 答复: Call for WG consensus on Tracker Protocol encoding

Jinwei

Hi all

- SDP 

- XML

- JSON

Best regard

Mário Nunes

Hi to all,

Best Regards,

João Pedro Taveira

On Thu Nov 13 2014 at 8:05:21 AM Huangyihong (Rachel) <[email-masked]> wrote:

Hi  all,

BR,

Rachel

Hi, all,

Thanks.

-Yunfei & Ning

---

From: "Roni Even" <[email-masked]>
Date: Thu, 13 Nov 2014 22:11:26 +0200

Hi,

Text encoding make sense for me. JSON can be used.

Roni Even

From: ppsp [mailto:[email-masked]] On Behalf Of Zongning
Sent: 13 November, 2014 4:28 AM
To: [email-masked]
Subject: [ppsp] Call for WG consensus on Tracker Protocol encoding

Hi, all,

Firstly, thanks to the co-authors of Base Tracker Protocol for persistently
moving the draft forward.

Now the outstanding issue is that as a Standard Track document, we really
NEED to agree on a mandatory encoding for the interoperable on-the-wire
Tracker Protocol. As discussed in the PPSP session today, we will start WGLC
for the draft, provided that we can reach a rough consensus on the encoding
option and the co-authors revise the draft accordingly.

Currently we have two options mentioned in the draft - they are text based
and binary based. For an exemplary comparison, please see Section 3.1 in the
draft. Could folks in the group give their opinions on which encoding option
is preferred for Tracker Protocol, and why? People are welcome to give other
options beyond text and binary, but please do show us the reason for
choosing them.

Thanks.

-Yunfei & Ning

---

From: 邓灵莉/Lingli Deng <[email-masked]>
Date: Fri, 14 Nov 2014 07:41:39 +0800

Dear Chairs,

Speaking as one of the co-authors for the base tracker protocol, we are happy to take whatever the group feels right.

But would you mind setting a clear time limit for this poll? 

Thanks,

Lingli

Hi, all,

Thanks.

-Yunfei & Ning

---

From: Zongning <[email-masked]>
Date: Thu, 13 Nov 2014 23:57:39 +0000

Hi, Lingli,

Yunfei and I are working on roadmap of all I-Ds in PPSP, and will post on the list soon.

The poll for encoding will be open till the *end of next week*.

Thanks.

-Ning

发件人: 邓灵莉/Lingli Deng [mailto:[email-masked]]
发送时间: 2014年11月13日 13:42
收件人: Zongning; [email-masked]
主题: RE: [ppsp] Call for WG consensus on Tracker Protocol encoding

Dear Chairs,

Thanks,
Lingli

Hi, all,

Thanks.

-Yunfei & Ning

---

From: "[email-masked]" <[email-masked]>
Date: Fri, 14 Nov 2014 11:38:38 -0500

Text encoding here too!

JR

On 13/11/2014 03:11 p.m., Roni Even wrote:
> *From:*ppsp [mailto:[email-masked]] *On Behalf Of *Zongning
> *Sent:* 13 November, 2014 4:28 AM
> *To:* [email-masked]
> Now the outstanding issue is that as a Standard Track document, we 
> really NEED to agree on a mandatory encoding for the interoperable 
> on-the-wire Tracker Protocol. As discussed in the PPSP session today, 
> we will start WGLC for the draft, provided that we can reach a rough 
> consensus on the encoding option and the co-authors revise the draft 
> accordingly.
>
> Currently we have two options mentioned in the draft -- they are text 
> based and binary based. For an exemplary comparison, please see 
> Section 3.1 in the draft. Could folks in the group give their opinions 
> on which encoding option is preferred for Tracker Protocol, and why? 
> People are welcome to give other options beyond text and binary, but 
> please do show us the reason for choosing them.
>
> The during of this call will not last too long, before the co-chairs 
> will make a decision. So, please do contribute your technical 
> expertise in this perspective, to enlight the group.
>
> Thanks.
>
> -Yunfei & Ning
>
>
>

-- 

----------------------------------------------------------------------
Javier Rodriguez
Por una mayor y mejor Internet(1995).
Internet libre, abierta, inclusiva y gratuita para todos (2013).
Fundador de: eCOML@C, GAC, LimaNet , Axisnet, redPE.
Fundador y primer presidente de ISOC-Perú
Miembro de ISOC Internacional, DIPLO IGC, CircleID, cgiPE, i17Peru.
----------------------------------------------------------------------
I believe in a bigger & better Internet (1995).
I work for an open, free, inclusive and cero cost internet (2013).
Founder of: eCOML@C, GAC, LimaNet, Axisnet, redPE.
Founder and first president of ISOC-Perú.
Member of ISOC International, DIPLO IGC, CircleID, cgiPE, i17Peru.
----------------------------------------------------------------------
Computing (1980). PC business (1983). UUCP (1985). Internet (1990).
Commercial Internet (1995). eCommerce (2000). Net Intelligence (2003).
----------------------------------------------------------------------
CONTACTO | SOCIAL LINKS
[email-masked]
[email-masked]
http://facebook.com/NetLiberum
http://facebook.com/InternetLibrePeru
https://twitter.com/NetLiberum
@NetLiberum

PUBLICACIONES | PAPERS
http://netliberum.blogspot.com/
http://InternetLibrePeru.wordpress.com
http://www.circleid.com/members/6980/
http://www.diplointernetgovernance.org/profile/JavierRodriguez
http://paper.li/NetLiberum/1361689316 (Internet Libre en Español)
http://paper.li/NetLiberum/1399039265 (NetLiberum | English edition)
----------------------------------------------------------------------

---

From: Dave Cottlehuber <[email-masked]>
Date: Fri, 21 Nov 2014 14:31:30 +0100

> >The poll for encoding will be open till the *end of next week*.

Given we are writing a *transport* protocol and not an http server, I would opt for binary encoding as mandatory. Optional text encoding if necessary.

The more fat we mix into the the tracker protocol, the less useful it becomes.

—
Dave Cottlehuber
[email-masked]
+43 688 60 56 21 44
Sent from the Cloud

---

From: Zongning <[email-masked]>
Date: Fri, 21 Nov 2014 16:24:10 +0000

Thanks, Dave.

Speaking as individual, I don't believe binary encoding is mandatory simply because we are writing protocol in transport area. :-)

-Ning

-----邮件原件-----
发件人: ppsp [mailto:[email-masked]] 代表 Dave Cottlehuber
发送时间: 2014年11月21日 6:32
收件人: [email-masked]
主题: Re: [ppsp] ***SPAM*** 8.616 (5) Re: 答复: Call for WG consensus on Tracker Protocol encoding

—
Dave Cottlehuber
[email-masked]
+43 688 60 56 21 44
Sent from the Cloud

---

From: "Huangyihong (Rachel)" <[email-masked]>
Date: Mon, 24 Nov 2014 01:48:53 +0000

Hi Dave,

IMO, tracker protocol is only about the signaling of peer information, rather than content communications as for the peer protocol. There's no big data exchanging in tracker protocol. So I don't think binary has more advantages than text encoding. In fact, since we use HTTP over TCP as the transport protocol for tracker protocol (perfect solution for NAT traversal, not because we're going to design a HTTP server), it's better to use text encoding for easy understanding. Besides, you can easily find protocols specified in IETF transport area, like alto protocol, using text encoding. 

BR,
Rachel

> -----Original Message-----
> From: ppsp [mailto:[email-masked]] On Behalf Of Dave Cottlehuber
> Sent: Friday, November 21, 2014 9:32 PM
> To: [email-masked]
> Subject: Re: [ppsp] ***SPAM*** 8.616 (5) Re: 答复: Call for WG consensus on
> Tracker Protocol encoding
> 
> > >Hi, Lingli,
> > >
> Given we are writing a *transport* protocol and not an http server, I would opt
> for binary encoding as mandatory. Optional text encoding if necessary.
>